OGRE: Ogre::SubMesh Class Reference - OGRE Documentation

Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::SubMesh Class Reference

Defines a part of a complete mesh. More...

`#include <OgreSubMesh.h>`

List of all members.

## Public Types

typedef std::vector< unsigned short > | IndexMap
| Dedicated index map for translate blend index to bone index (only valid if useSharedVertices = false).
typedef std::multimap< size_t, VertexBoneAssignment > | VertexBoneAssignmentList
| Multimap of verex bone assignments (orders by vertex index).
typedef MapIterator< VertexBoneAssignmentList > | BoneAssignmentIterator
typedef ConstMapIterator< AliasTextureNamePairList > | AliasTextureIterator

## Public Member Functions

| SubMesh ()
| ~SubMesh ()
void | setMaterialName (const String &matName)
| Sets the name of the Material which this SubMesh will use.
const String & | getMaterialName (void) const
bool | isMatInitialised (void) const
| Returns true if a material has been assigned to the submesh, otherwise returns false.
void | _getRenderOperation (RenderOperation &rend, ushort lodIndex=0)
| Returns a RenderOperation structure required to render this mesh.
void | addBoneAssignment (const VertexBoneAssignment &vertBoneAssign)
| Assigns a vertex to a bone with a given weight, for skeletal animation.
void | clearBoneAssignments (void)
| Removes all bone assignments for this mesh.
BoneAssignmentIterator | getBoneAssignmentIterator (void)
| Gets an iterator for access all bone assignments.
void | _compileBoneAssignments (void)
| Must be called once to compile bone assignments into geometry buffer.
AliasTextureIterator | getAliasTextureIterator (void) const
| Gets an constant iterator to access all texture alias names assigned to this submesh.
void | addTextureAlias (const String &aliasName, const String &textureName)
| Adds the alias or replaces an existing one and associates the texture name to it.
void | removeTextureAlias (const String &aliasName)
| Remove a specific texture alias name from the sub mesh.
void | removeAllTextureAliases (void)
| removes all texture aliases from the sub mesh
bool | hasTextureAliases (void) const
| returns true if the sub mesh has texture aliases
size_t | getTextureAliasCount (void) const
| Gets the number of texture aliases assigned to the sub mesh.
bool | updateMaterialUsingTextureAliases (void)
| The current material used by the submesh is copied into a new material and the submesh's texture aliases are applied if the current texture alias names match those found in the original material.
VertexAnimationType | getVertexAnimationType (void) const
| Get the type of any vertex animation used by dedicated geometry.
void | generateExtremes (size_t count)
| Generate the submesh extremes (.

## Public Attributes

bool | useSharedVertices
| Indicates if this submesh shares vertex data with other meshes or whether it has it's own vertices.
RenderOperation::OperationType | operationType
| The render operation type used to render this submesh.
VertexData * | vertexData
| Dedicated vertex data (only valid if useSharedVertices = false).
IndexData * | indexData
| Face index data.
IndexMap | blendIndexToBoneIndexMap
ProgressiveMesh::LODFaceList | mLodFaceList
std::vector< Vector3 > | extremityPoints
| A list of extreme points on the submesh (optional).
Mesh * | parent
| Reference to parent Mesh (not a smart pointer so child does not keep parent alive).

## Protected Member Functions

void | removeLodLevels (void)
| Internal method for removing LOD data.

## Protected Attributes

String | mMaterialName
| Name of the material this SubMesh uses.
bool | mMatInitialised
| Is there a material yet?
AliasTextureNamePairList | mTextureAliases
| paired list of texture aliases and texture names
VertexBoneAssignmentList | mBoneAssignments
bool | mBoneAssignmentsOutOfDate
| Flag indicating that bone assignments need to be recompiled.
VertexAnimationType | mVertexAnimationType
| Type of vertex animation for dedicated vertex data (populated by Mesh).

## Friends

class | Mesh
class | MeshSerializerImpl
class | MeshSerializerImpl_v1_2
class | MeshSerializerImpl_v1_1

## Detailed Description

Defines a part of a complete mesh.

Remarks:
  Meshes which make up the definition of a discrete 3D object are made up of potentially multiple parts. This is because different parts of the mesh may use different materials or use different vertex formats, such that a rendering state change is required between them.

  Like the Mesh class, instatiations of 3D objects in the scene share the SubMesh instances, and have the option of overriding their material differences on a per-object basis if required. See the SubEntity class for more information.

Definition at line 56 of file OgreSubMesh.h.

## Member Typedef Documentation

typedef ConstMapIterator<AliasTextureNamePairList> Ogre::SubMesh::AliasTextureIterator

| Definition at line 183 of file OgreSubMesh.h.

typedef MapIterator<VertexBoneAssignmentList> Ogre::SubMesh::BoneAssignmentIterator

| Definition at line 172 of file OgreSubMesh.h.

typedef std::vector<unsigned short> Ogre::SubMesh::IndexMap

Dedicated index map for translate blend index to bone index (only valid if useSharedVertices = false).

Remarks:
  This data is completely owned by this submesh.

  We collect actually used bones of all bone assignments, and build the blend index in 'packed' form, then the range of the blend index in vertex data VES_BLEND_INDICES element is continuous, with no gaps. Thus, by minimising the world matrix array constants passing to GPU, we can support more bones for a mesh when hardware skinning is used. The hardware skinning support limit is applied to each set of vertex data in the mesh, in other words, the hardware skinning support limit is applied only to the actually used bones of each SubMeshes, not all bones across the entire Mesh.

  Because the blend index is different to the bone index, therefore, we use the index map to translate the blend index to bone index.

  The use of shared or non-shared index map is determined when model data is converted to the OGRE .mesh format.

Definition at line 104 of file OgreSubMesh.h.

typedef std::multimap<size_t, VertexBoneAssignment> Ogre::SubMesh::VertexBoneAssignmentList

| Multimap of verex bone assignments (orders by vertex index). Definition at line 171 of file OgreSubMesh.h.

## Constructor & Destructor Documentation

Ogre::SubMesh::SubMesh | ( |  | ) |

Ogre::SubMesh::~SubMesh | ( |  | ) |

## Member Function Documentation

void Ogre::SubMesh::_compileBoneAssignments | ( | void |  | ) |

| Must be called once to compile bone assignments into geometry buffer.

void Ogre::SubMesh::_getRenderOperation | ( | RenderOperation & | rend,
|  | ushort | lodIndex = `0`
| ) |

Returns a RenderOperation structure required to render this mesh.

Parameters:

  | rend | Reference to a RenderOperation structure to populate.
  | lodIndex | The index of the LOD to use.

void Ogre::SubMesh::addBoneAssignment | ( | const VertexBoneAssignment & | vertBoneAssign | ) |

Assigns a vertex to a bone with a given weight, for skeletal animation.

Remarks:
  This method is only valid after calling setSkeletonName. Since this is a one-off process there exists only 'addBoneAssignment' and 'clearBoneAssignments' methods, no 'editBoneAssignment'. You should not need to modify bone assignments during rendering (only the positions of bones) and OGRE reserves the right to do some internal data reformatting of this information, depending on render system requirements.

  This method is for assigning weights to the dedicated geometry of the SubMesh. To assign weights to the shared Mesh geometry, see the equivalent methods on Mesh.

void Ogre::SubMesh::addTextureAlias | ( | const String & | aliasName,
|  | const String & | textureName
| ) |

Adds the alias or replaces an existing one and associates the texture name to it.

Remarks:
  The submesh uses the texture alias to replace textures used in the material applied to the submesh.

Parameters:

  | aliasName | is the name of the alias.
  | textureName | is the name of the texture to be associated with the alias

void Ogre::SubMesh::clearBoneAssignments | ( | void |  | ) |

Removes all bone assignments for this mesh.

  This method is for assigning weights to the dedicated geometry of the SubMesh. To assign weights to the shared Mesh geometry, see the equivalent methods on Mesh.

void Ogre::SubMesh::generateExtremes | ( | size_t | count | ) |

Generate the submesh extremes (.

See also:
  extremityPoints).

Parameters:

  | count | Number of extreme points to compute for the submesh.

AliasTextureIterator Ogre::SubMesh::getAliasTextureIterator | ( | void |  | ) | const

| Gets an constant iterator to access all texture alias names assigned to this submesh.

BoneAssignmentIterator Ogre::SubMesh::getBoneAssignmentIterator | ( | void |  | ) |

Gets an iterator for access all bone assignments.

Remarks:
  Only valid if this SubMesh has dedicated geometry.

const String& Ogre::SubMesh::getMaterialName | ( | void |  | ) | const

size_t Ogre::SubMesh::getTextureAliasCount | ( | void |  | ) | const

| Gets the number of texture aliases assigned to the sub mesh. Definition at line 213 of file OgreSubMesh.h.

VertexAnimationType Ogre::SubMesh::getVertexAnimationType | ( | void |  | ) | const

| Get the type of any vertex animation used by dedicated geometry.

bool Ogre::SubMesh::hasTextureAliases | ( | void |  | ) | const

| returns true if the sub mesh has texture aliases Definition at line 210 of file OgreSubMesh.h.

bool Ogre::SubMesh::isMatInitialised | ( | void |  | ) | const

| Returns true if a material has been assigned to the submesh, otherwise returns false.

void Ogre::SubMesh::removeAllTextureAliases | ( | void |  | ) |

| removes all texture aliases from the sub mesh

void Ogre::SubMesh::removeLodLevels | ( | void |  | ) | `[protected]`

| Internal method for removing LOD data.

void Ogre::SubMesh::removeTextureAlias | ( | const String & | aliasName | ) |

Remove a specific texture alias name from the sub mesh.

Parameters:

  | aliasName | is the name of the alias to be removed. If it is not found then it is ignored.

void Ogre::SubMesh::setMaterialName | ( | const String & | matName | ) |

| Sets the name of the Material which this SubMesh will use.

bool Ogre::SubMesh::updateMaterialUsingTextureAliases | ( | void |  | ) |

The current material used by the submesh is copied into a new material and the submesh's texture aliases are applied if the current texture alias names match those found in the original material.

Remarks:
  The submesh's texture aliases must be setup prior to calling this method. If a new material has to be created, the subMesh autogenerates the new name. The new name is the old name + "_" + number.

Returns:
  True if texture aliases were applied and a new material was created.

## Friends And Related Function Documentation

friend class Mesh`[friend]`

| Definition at line 58 of file OgreSubMesh.h.

friend class MeshSerializerImpl`[friend]`

| Definition at line 59 of file OgreSubMesh.h.

friend class MeshSerializerImpl_v1_1`[friend]`

| Definition at line 61 of file OgreSubMesh.h.

friend class MeshSerializerImpl_v1_2`[friend]`

| Definition at line 60 of file OgreSubMesh.h.

## Member Data Documentation

IndexMap Ogre::SubMesh::blendIndexToBoneIndexMap

| Definition at line 105 of file OgreSubMesh.h.

std::vector<Vector3> Ogre::SubMesh::extremityPoints

A list of extreme points on the submesh (optional).

Remarks:
  These points are some arbitrary points on the mesh that are used by engine to better sort submeshes by depth. This doesn't matter much for non-transparent submeshes, as Z-buffer takes care of invisible surface culling anyway, but is pretty useful for semi-transparent submeshes because the order in which transparent submeshes must be rendered cannot be always correctly deduced from entity position.

  These points are intelligently chosen from the points that make up the submesh, the criteria for choosing them should be that these points somewhat characterize the submesh outline, e.g. they should not be close to each other, and they should be on the outer hull of the submesh. They can be stored in the .mesh file, or generated at runtime (see generateExtremes ()).

  If this array is empty, submesh sorting is done like in older versions - by comparing the positions of the owning entity.

Definition at line 128 of file OgreSubMesh.h.

IndexData* Ogre::SubMesh::indexData

| Face index data. Definition at line 83 of file OgreSubMesh.h.

VertexBoneAssignmentList Ogre::SubMesh::mBoneAssignments`[protected]`

| Definition at line 248 of file OgreSubMesh.h.

bool Ogre::SubMesh::mBoneAssignmentsOutOfDate`[protected]`

| Flag indicating that bone assignments need to be recompiled. Definition at line 251 of file OgreSubMesh.h.

ProgressiveMesh::LODFaceList Ogre::SubMesh::mLodFaceList

| Definition at line 107 of file OgreSubMesh.h.

String Ogre::SubMesh::mMaterialName`[protected]`

| Name of the material this SubMesh uses. Definition at line 240 of file OgreSubMesh.h.

bool Ogre::SubMesh::mMatInitialised`[protected]`

| Is there a material yet? Definition at line 243 of file OgreSubMesh.h.

AliasTextureNamePairList Ogre::SubMesh::mTextureAliases`[protected]`

| paired list of texture aliases and texture names Definition at line 246 of file OgreSubMesh.h.

VertexAnimationType Ogre::SubMesh::mVertexAnimationType`[mutable, protected]`

| Type of vertex animation for dedicated vertex data (populated by Mesh). Definition at line 254 of file OgreSubMesh.h.

RenderOperation::OperationType Ogre::SubMesh::operationType

| The render operation type used to render this submesh. Definition at line 71 of file OgreSubMesh.h.

Mesh* Ogre::SubMesh::parent

| Reference to parent Mesh (not a smart pointer so child does not keep parent alive). Definition at line 131 of file OgreSubMesh.h.

bool Ogre::SubMesh::useSharedVertices

| Indicates if this submesh shares vertex data with other meshes or whether it has it's own vertices. Definition at line 68 of file OgreSubMesh.h.

VertexData* Ogre::SubMesh::vertexData

Dedicated vertex data (only valid if useSharedVertices = false).

Remarks:
  This data is completely owned by this submesh.

  The use of shared or non-shared buffers is determined when model data is converted to the OGRE .mesh format.

Definition at line 80 of file OgreSubMesh.h.

The documentation for this class was generated from the following file:

- OgreSubMesh.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:49:16 2008